/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// ProductSpecificationRef Product specification reference: A ProductSpecification is a detailed description of a tangible or intangible object made available externally in the form of a ProductOffering to customers or other parties playing a party role.
type ProductSpecificationRef struct {
	// Unique identifier of a related entity.
	Id string `json:"id"`
	// Reference of the related entity.
	Href *string `json:"href,omitempty"`
	// Name of the related entity.
	Name *string `json:"name,omitempty"`
	// Version of the product specification
	Version *string `json:"version,omitempty"`
	TargetProductSchema *TargetProductSchema `json:"targetProductSchema,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
	// The actual type of the target instance when needed for disambiguation.
	ReferredType *string `json:"@referredType,omitempty"`
}

// NewProductSpecificationRef instantiates a new ProductSpecificationRef object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProductSpecificationRef(id string, ) *ProductSpecificationRef {
	this := ProductSpecificationRef{}
	this.Id = id
	return &this
}

// NewProductSpecificationRefWithDefaults instantiates a new ProductSpecificationRef object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductSpecificationRefWithDefaults() *ProductSpecificationRef {
	this := ProductSpecificationRef{}
	return &this
}

// GetId returns the Id field value
func (o *ProductSpecificationRef) GetId() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ProductSpecificationRef) SetId(v string) {
	o.Id = v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *ProductSpecificationRef) SetHref(v string) {
	o.Href = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ProductSpecificationRef) SetName(v string) {
	o.Name = &v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetVersion() string {
	if o == nil || o.Version == nil {
		var ret string
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetVersionOk() (*string, bool) {
	if o == nil || o.Version == nil {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasVersion() bool {
	if o != nil && o.Version != nil {
		return true
	}

	return false
}

// SetVersion gets a reference to the given string and assigns it to the Version field.
func (o *ProductSpecificationRef) SetVersion(v string) {
	o.Version = &v
}

// GetTargetProductSchema returns the TargetProductSchema field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetTargetProductSchema() TargetProductSchema {
	if o == nil || o.TargetProductSchema == nil {
		var ret TargetProductSchema
		return ret
	}
	return *o.TargetProductSchema
}

// GetTargetProductSchemaOk returns a tuple with the TargetProductSchema field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetTargetProductSchemaOk() (*TargetProductSchema, bool) {
	if o == nil || o.TargetProductSchema == nil {
		return nil, false
	}
	return o.TargetProductSchema, true
}

// HasTargetProductSchema returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasTargetProductSchema() bool {
	if o != nil && o.TargetProductSchema != nil {
		return true
	}

	return false
}

// SetTargetProductSchema gets a reference to the given TargetProductSchema and assigns it to the TargetProductSchema field.
func (o *ProductSpecificationRef) SetTargetProductSchema(v TargetProductSchema) {
	o.TargetProductSchema = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *ProductSpecificationRef) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *ProductSpecificationRef) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ProductSpecificationRef) SetType(v string) {
	o.Type = &v
}

// GetReferredType returns the ReferredType field value if set, zero value otherwise.
func (o *ProductSpecificationRef) GetReferredType() string {
	if o == nil || o.ReferredType == nil {
		var ret string
		return ret
	}
	return *o.ReferredType
}

// GetReferredTypeOk returns a tuple with the ReferredType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductSpecificationRef) GetReferredTypeOk() (*string, bool) {
	if o == nil || o.ReferredType == nil {
		return nil, false
	}
	return o.ReferredType, true
}

// HasReferredType returns a boolean if a field has been set.
func (o *ProductSpecificationRef) HasReferredType() bool {
	if o != nil && o.ReferredType != nil {
		return true
	}

	return false
}

// SetReferredType gets a reference to the given string and assigns it to the ReferredType field.
func (o *ProductSpecificationRef) SetReferredType(v string) {
	o.ReferredType = &v
}

func (o ProductSpecificationRef) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Version != nil {
		toSerialize["version"] = o.Version
	}
	if o.TargetProductSchema != nil {
		toSerialize["targetProductSchema"] = o.TargetProductSchema
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	if o.ReferredType != nil {
		toSerialize["@referredType"] = o.ReferredType
	}
	return json.Marshal(toSerialize)
}

type NullableProductSpecificationRef struct {
	value *ProductSpecificationRef
	isSet bool
}

func (v NullableProductSpecificationRef) Get() *ProductSpecificationRef {
	return v.value
}

func (v *NullableProductSpecificationRef) Set(val *ProductSpecificationRef) {
	v.value = val
	v.isSet = true
}

func (v NullableProductSpecificationRef) IsSet() bool {
	return v.isSet
}

func (v *NullableProductSpecificationRef) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProductSpecificationRef(val *ProductSpecificationRef) *NullableProductSpecificationRef {
	return &NullableProductSpecificationRef{value: val, isSet: true}
}

func (v NullableProductSpecificationRef) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProductSpecificationRef) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


